package main

import (
	"fmt"
	"golang.org/x/text/encoding/charmap"
	"io"
	"io/ioutil"
	"os"
	"path/filepath"
	"strings"
)
/////////////////////////////////////////////////////




////////////////////////////////////////////////
// путь к исполняемому файлу
var MainPathExeFile string
func GetMainPathExeFile() string {
	//	mainPathExeFile=os.Args[0] - путь с самим файлом
	ex, err := os.Executable()
	if err != nil {
		panic(err)
	}
	//	mainPathExeFile, _ = filepath.EvalSymlinks(ex)  - путь с самим файлом
	MainPathExeFile = filepath.Dir(ex)
	return MainPathExeFile
}
// считывание файла в строку
func ReadFileContent(file string) string {
	data, err := ioutil.ReadFile(file)
	if err != nil {
		return ""
	}
	return string(data)
}
func ReadANSIfileContent(file string) string {
	data, err := ioutil.ReadFile(file)
	if err != nil {
		return ""
	}
	// декодировать содержимое файла из кодировки windows-1251
	decoder := charmap.Windows1251.NewDecoder()
	decodedData, err2 := decoder.Bytes(data)
	if err2 != nil {
		return ""
	}
	// конвертировать декодированное содержимое файла в UTF-8
	utf8Data := string(decodedData)

	return utf8Data
}
/////////////////////////////////////////


// записать файл, если нет - создать
func WriteFileContent(file string, content string) {
	if len(content) == 0 {
		return
	}
	//	f, _ := os.OpenFile(file,os.O_CREATE, 0666)
	f, _ := os.Create(file)
	f.WriteString(content)
	//	fmt.Println("Запись: ", err);
	defer f.Close()
}
// копирование локального файлов
func copyLocalFile1toFile2(src, dst string) error {
	// если нет такой папки в локале, то создать
	// удалить файл на конце, т.е. обрезать по последнюю /
	dir := filepath.Dir(dst)
	err := os.MkdirAll(dir, 0755)
	if err != nil {
		return err
	}

	content:=ReadFileContent(src)
	WriteFileContent(dst, content)

	return nil
}
/////////////////////////////////////////////////////








/* создать папки в корне локального репозитория GetMainPathExeFile() + директория файла
удалить файл на конце, т.е. обрезать по последнюю /

 */
func createDirsFromPath(filePath string)bool{
	// удалить файл на конце, т.е. обрезать по последнюю /
	dir := filepath.Dir(filePath)
	//path:=GetMainPathExeFile()+dir
	path:=dir
	path= strings.ReplaceAll(path, "//", "/")
	path= strings.ReplaceAll(path, "\\", "/")
	err := os.MkdirAll(path, 0755)
	if err != nil {
		fmt.Println("Ошибка при создании локальной папки: "+filePath)
	}
	return true
}
////////////////////////////////////////////////



////////////////////////////////////////////////////
// залить файл  с созданием папок
func copyLocalFile(file_from string, file_to string)bool{

	// если нет такой папки в локале, то создать
	// удалить файл на конце, т.е. обрезать по последнюю /
	dir := filepath.Dir(file_to)
	err := os.MkdirAll(dir, 0755)
	if err != nil {
		return false
	}

	// Открываем file_from на чтение
	source, err := os.Create(file_from)
	if err != nil {
		return false
	}
	defer source.Close()
	// Создаем новый файл в папке назначения
	dest, err := os.Create(file_to)
	if err != nil {
		return false
	}
	defer dest.Close()

	// Копируем данные из file_from в file_to
	_, err = io.Copy(dest, source)
	if err == nil {
		return true
	}
	return false
}
////////////////////////////////////////////////////





/*удалить на локальном сервере файлы по списку
при удалении файлов смотреть, если папка опустела, то удалять ее, но удаление пустых папок не обязательно.
 */
func deleteLocalFile(file string)bool{

		err := os.Remove(file)
		if err != nil {
			return false
		}

	return true
}
/////////////////////////////////////////////////



