/*

Для запрета двойного запуска есть переменная
var debug = false // переключать true - для дебаг и false - релиз компилированием
В принципе она может быть все время debug = false, только не забывать закрывать кнопкой Завершить работу страницы браузера.

Для того чтобы запустить исполняемый файл без появления окна консоли в Goland
в Run конфигурации в поле "Go tool arguments" нужно прописать: -ldflags "-H windowsgui"
т.е. в меню EDIT/Edit configeration/ нужно сделать две конфигурации: Run и Debag и только для Run
в поле "Go tool arguments" нужно прописать: -ldflags "-H windowsgui"
а для конфигурации Debug в поле "Go tool arguments" прописать -i - чтобы там была debug информация


go get github.com/mitchellh/go-ps
 */



package main

import (
	"fmt"
	"github.com/mitchellh/go-ps"
	"net/http"
	"os"
	"strings"
	"time"
	_ "time"
)

//////////////////////////////////////////
// если тестирование, писать в файл последовательность происходящего addLogsLine()
var isTesting=false // false true

var noСloseWeght=false// на время перезагрузки НЕ закрывать прогу

var check_connect_counter=0//счетчик для контроля, что нет check_connect более 300 секунд
var isRunWorkProcess=false// выполняется рабочий процесс и нужно сбрасывать check_connect_counter

/* Нужно определять, что открыта только одна вэб-страница vcs!
Дело в том, что каждая страница будет продолжать молотить запросы по одному порту.
Они будут поступать в открытый сервер ГО. Каждый запрос страницы передает случайное число rand_marker
и если приходят несколько таких чисел, то отрыты несколько страниц.
 */
var randMarkers []int

var selectedProject="" // имя выбранного проекта

func cleanupFunc() {// что-то сделать перед закрытием приложения из браузера

	//saveLocalInfo(nil)
}



func main() {

	onlyOneApp() // Всегда контролировать единственность запущенного экземпляра на данном компьютере
	//////////////////////////////////////////////////////

	if isTesting{
		file:=GetMainPathExeFile()+"/process_log.txt"
		file= strings.ReplaceAll(file, "\\", "/")
		WriteFileContent(file, "Последовательность процессов\r\r\n\r")
	}

	beginWork()

//	showBrauserPage("1") // проверка
/* При каждой проверке соединения (check_connect)
сбрасывается check_connect_counter=0
Если соединения нет более 300 секунд - срабатывает
   if check_connect_counter >150{
и откывается showBrauserPage("1") вэб-страница vcs_warning.htm с сообщением.
 */
	ticker := time.NewTicker(1*time.Second)
	//defer ticker.Stop()  постоянно молотит
	go func() {
		for {
			select {
			case <-ticker.C:
				if isRunWorkProcess{
					check_connect_counter=0
				}
				if len(selectedProject)==0{// еще не выбран проект
					check_connect_counter=0
				}
				if check_connect_counter >150{
					// нет check_connect более 300 секунд, вероятно закрыт браузер
					showBrauserPage("1")
					check_connect_counter=0
					os.Exit(1)
				}
				check_connect_counter++
				//checkNormalConnection()
			}
		}
	}()



	http.HandleFunc("/", receiveSend)
	fmt.Println("Сервер запущен...")
	_ = http.ListenAndServe("127.0.0.1:8182", nil)


	// Используем select{} для бесконечного ожидания событий без блокировки чтобы предовратить завершение главного процесса.
	select {}// но работает и без этого
}
/////////////////////////////////////////////////

func beginWork(){

	// открыть главную страницу в Хроме
	showBrauserPage("")


}
///////////////////////////////////////////////


/* Проверяем, был ли ранее запущен run.exe на данном компьютере
!!!! у все у них будет один порт связи с вэбстраницей (http://127.0.0.1:8182)
Это приведет к лажам.... !!!!
Поэтому открываем вэи-страницу vcs_warning_2.htm и закрываем приложение
 */
func onlyOneApp() { // return

	pid := os.Getpid()// идентификатор текущего процесса
	// Получение списка процессов
	processes, err := ps.Processes()
	if err == nil {
		for _, p := range processes {
			if p.Executable() == "sVCS.exe" && p.Pid() != pid {
				XXXXaddLogsLine("onlyOneApp(): УЖЕ ЕСТЬ ЗАПУЩЕННЫЙ ЕХЕ. Выключение приложения. ")
				showBrauserPage("2")
				os.Exit(1)
				return
			}
		}
	}
}
////////////////////////////////////////////////////////

















